import { __spread } from 'tslib';
import { CommonModule } from '@angular/common';
import { Component, HostBinding, Input, InjectionToken, Directive, ElementRef, Host, Optional, SkipSelf, ContentChild, Inject, EventEmitter, HostListener, Output, NgModule } from '@angular/core';
import { ControlContainer, FormControl, FormArray, FormGroup, NgForm } from '@angular/forms';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ValidationFeedbackComponent = /** @class */ (function () {
    function ValidationFeedbackComponent() {
        this.messages = function () { return []; };
    }
    Object.defineProperty(ValidationFeedbackComponent.prototype, "classes", {
        // TODO support valid-feedback as well
        get: 
        // TODO support valid-feedback as well
        /**
         * @return {?}
         */
        function () {
            return true;
        },
        enumerable: true,
        configurable: true
    });
    ValidationFeedbackComponent.decorators = [
        { type: Component, args: [{
                    selector: 'wp-validation-feedback',
                    template: "<span *ngFor=\"let message of messages()\">{{message}}</span>",
                    styles: [".invalid-feedback,.valid-feedback{display:block}"]
                }] }
    ];
    /** @nocollapse */
    ValidationFeedbackComponent.ctorParameters = function () { return []; };
    ValidationFeedbackComponent.propDecorators = {
        messages: [{ type: Input }],
        classes: [{ type: HostBinding, args: ['class.invalid-feedback',] }]
    };
    return ValidationFeedbackComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
var DEFAULT_ERRORS = [
    {
        error: 'required',
        format: function (label) { return label + " is required."; }
    },
    {
        error: 'pattern',
        format: function (label) { return label + " is invalid."; }
    },
    {
        error: 'minlength',
        format: function (label, error) {
            return label + " must be at least " + error.requiredLength + " characters";
        }
    },
    {
        error: 'maxlength',
        format: function (label, error) {
            return label + " must be no longer than " + error.requiredLength + " characters";
        }
    },
    {
        error: 'requiredTrue',
        format: function (label) { return label + " is required"; }
    },
    {
        error: 'email',
        format: function () { return "Invalid email address"; }
    },
    {
        error: 'max',
        format: function (label, error) { return label + " must be no greater than " + error.max; }
    },
    {
        error: 'min',
        format: function (label, error) { return label + " must be no less than " + error.min; }
    }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
var CUSTOM_ERROR_MESSAGES = new InjectionToken('ng-bootstrap-validation-form-error-messages');

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @param {?} name
 * @param {?} parent
 * @return {?}
 */
function controlPath(name, parent) {
    // tslint:disable-next-line:no-non-null-assertion
    return __spread((/** @type {?} */ (parent.path)), [name]);
}
var FormControlDirective = /** @class */ (function () {
    function FormControlDirective(parent, formControl, elementRef) {
        this.parent = parent;
        this.formControl = formControl;
        this.elementRef = elementRef;
    }
    Object.defineProperty(FormControlDirective.prototype, "name", {
        get: /**
         * @return {?}
         */
        function () {
            if (this.formControlName) {
                return this.formControlName;
            }
            this.formControlName = this.elementRef.nativeElement.getAttribute('name');
            return this.formControlName;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FormControlDirective.prototype, "path", {
        // This method will be invoked by "getControl" method on "formDirective"
        get: 
        // This method will be invoked by "getControl" method on "formDirective"
        /**
         * @return {?}
         */
        function () {
            if (!this.formControlName) {
                this.formControlName = this.elementRef.nativeElement.getAttribute('name');
            }
            return controlPath(this.name, this.parent);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FormControlDirective.prototype, "validClass", {
        get: /**
         * @return {?}
         */
        function () {
            if (!this.control) {
                return false;
            }
            return this.control.valid && (this.control.touched || this.control.dirty);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FormControlDirective.prototype, "invalidClass", {
        get: /**
         * @return {?}
         */
        function () {
            if (!this.control) {
                return false;
            }
            return this.control.invalid && this.control.touched && this.control.dirty;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FormControlDirective.prototype, "control", {
        get: /**
         * @return {?}
         */
        function () {
            return this.formDirective && this.formDirective.getControl(this);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FormControlDirective.prototype, "formDirective", {
        get: /**
         * @return {?}
         */
        function () {
            return this.parent ? this.parent.formDirective : null;
        },
        enumerable: true,
        configurable: true
    });
    FormControlDirective.decorators = [
        { type: Directive, args: [{
                    // tslint:disable-next-line:directive-selector
                    selector: '.form-control,.form-check-input,.custom-control-input,[wpFormControl]'
                },] }
    ];
    /** @nocollapse */
    FormControlDirective.ctorParameters = function () { return [
        { type: ControlContainer, decorators: [{ type: Optional }, { type: Host }, { type: SkipSelf }] },
        { type: FormControl, decorators: [{ type: Optional }, { type: Host }] },
        { type: ElementRef }
    ]; };
    FormControlDirective.propDecorators = {
        formControlName: [{ type: Input }],
        validClass: [{ type: HostBinding, args: ['class.is-valid',] }],
        invalidClass: [{ type: HostBinding, args: ['class.is-invalid',] }]
    };
    return FormControlDirective;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var FormGroupComponent = /** @class */ (function () {
    function FormGroupComponent(elRef, customErrorMessages) {
        var _this = this;
        this.elRef = elRef;
        this.customErrorMessages = customErrorMessages;
        this.messages = function () { return _this.getMessages(); };
    }
    Object.defineProperty(FormGroupComponent.prototype, "hasErrors", {
        get: /**
         * @return {?}
         */
        function () {
            if (!this.formControlDirective) {
                return false;
            }
            return this.formControlDirective.control &&
                !this.formControlDirective.control.valid &&
                this.formControlDirective.control.dirty &&
                this.formControlDirective.control.touched;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FormGroupComponent.prototype, "hasSuccess", {
        get: /**
         * @return {?}
         */
        function () {
            if (!this.formControlDirective) {
                return false;
            }
            return this.formControlDirective.control &&
                this.formControlDirective.control.valid &&
                this.formControlDirective.control.dirty &&
                this.formControlDirective.control.touched;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @return {?}
     */
    FormGroupComponent.prototype.ngAfterContentInit = /**
     * @return {?}
     */
    function () {
        if (this.messagesBlock) {
            this.messagesBlock.messages = this.messages;
        }
    };
    /**
     * @return {?}
     */
    FormGroupComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        this.errorMessages = DEFAULT_ERRORS
            .concat(this.customErrorMessages)
            .reverse();
    };
    Object.defineProperty(FormGroupComponent.prototype, "label", {
        get: /**
         * @return {?}
         */
        function () {
            /** @type {?} */
            var label = this.elRef.nativeElement.querySelector('label');
            return label && label.textContent ? label.textContent.trim() : 'This field';
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FormGroupComponent.prototype, "isDirtyAndTouched", {
        get: /**
         * @return {?}
         */
        function () {
            if (!this.formControlDirective) {
                return false;
            }
            return this.formControlDirective.control &&
                this.formControlDirective.control.dirty &&
                this.formControlDirective.control.touched;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @private
     * @return {?}
     */
    FormGroupComponent.prototype.getMessages = /**
     * @private
     * @return {?}
     */
    function () {
        var _this = this;
        /** @type {?} */
        var messages = [];
        if (!this.isDirtyAndTouched) {
            return messages;
        }
        /** @type {?} */
        var errors = this.formControlDirective.control.errors;
        if (!errors) {
            return;
        }
        Object.keys(this.formControlDirective.control.errors).forEach(function (key) {
            /** @type {?} */
            var error = _this.errorMessages.find(function (err) { return err.error === key; });
            if (!error) {
                return;
            }
            messages.push(error.format(_this.label, _this.formControlDirective.control.errors[key]));
        });
        return messages;
    };
    FormGroupComponent.decorators = [
        { type: Component, args: [{
                    // tslint:disable:component-selector
                    selector: '.form-group,[wpFormGroup]',
                    template: "<ng-content></ng-content>\n<wp-validation-feedback *ngIf=\"!messagesBlock\" [messages]=\"messages\"></wp-validation-feedback>"
                }] }
    ];
    /** @nocollapse */
    FormGroupComponent.ctorParameters = function () { return [
        { type: ElementRef },
        { type: Array, decorators: [{ type: Inject, args: [CUSTOM_ERROR_MESSAGES,] }] }
    ]; };
    FormGroupComponent.propDecorators = {
        formControlDirective: [{ type: ContentChild, args: [FormControlDirective,] }],
        messagesBlock: [{ type: ContentChild, args: [ValidationFeedbackComponent,] }],
        hasErrors: [{ type: HostBinding, args: ['class.has-error',] }],
        hasSuccess: [{ type: HostBinding, args: ['class.has-success',] }]
    };
    return FormGroupComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var FormDirective = /** @class */ (function () {
    function FormDirective(ngForm, formGroup) {
        this.ngForm = ngForm;
        this.formGroup = formGroup;
        // https://stackoverflow.com/a/40706065/2405040
        this.validFormSubmit = new EventEmitter();
    }
    /**
     * @return {?}
     */
    FormDirective.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        if (!this.formGroup && this.ngForm) {
            this.formGroup = this.ngForm.form;
        }
    };
    /**
     * @return {?}
     */
    FormDirective.prototype.onSubmit = /**
     * @return {?}
     */
    function () {
        if (!this.formGroup) {
            console.warn('Could not find any formGroup or ngForm on the');
            return;
        }
        this.markAsTouchedAndDirty(this.formGroup);
        if (this.formGroup.valid) {
            this.validFormSubmit.emit(this.formGroup.value);
        }
    };
    /**
     * @private
     * @param {?} control
     * @return {?}
     */
    FormDirective.prototype.markAsTouchedAndDirty = /**
     * @private
     * @param {?} control
     * @return {?}
     */
    function (control) {
        var _this = this;
        if (control instanceof FormGroup) {
            Object.keys(control.controls).forEach(function (key) {
                _this.markAsTouchedAndDirty(control.controls[key]);
            });
        }
        else if (control instanceof FormArray) {
            control.controls.forEach(function (c) { return _this.markAsTouchedAndDirty(c); });
        }
        else if (control instanceof FormControl && control.enabled) {
            control.markAsDirty();
            control.markAsTouched();
            control.updateValueAndValidity();
        }
    };
    FormDirective.decorators = [
        { type: Directive, args: [{
                    selector: '[wpForm]'
                },] }
    ];
    /** @nocollapse */
    FormDirective.ctorParameters = function () { return [
        { type: NgForm, decorators: [{ type: Optional }, { type: Host }] },
        { type: FormGroup, decorators: [{ type: Optional }, { type: Host }] }
    ]; };
    FormDirective.propDecorators = {
        wpForm: [{ type: Input }],
        validFormSubmit: [{ type: Output }],
        onSubmit: [{ type: HostListener, args: ['submit',] }]
    };
    return FormDirective;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ɵ0 = function (form) {
    return form;
};
// @dynamic
var ParentFormDirective = /** @class */ (function () {
    function ParentFormDirective() {
    }
    ParentFormDirective.decorators = [
        { type: Directive, args: [{
                    selector: '[wpLinkParentForm]',
                    providers: [
                        {
                            provide: ControlContainer,
                            useFactory: ɵ0,
                            deps: [NgForm]
                        }
                    ]
                },] }
    ];
    return ParentFormDirective;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NgxBootstrapValidationModule = /** @class */ (function () {
    function NgxBootstrapValidationModule() {
    }
    /**
     * @param {?} customErrorMessages
     * @return {?}
     */
    NgxBootstrapValidationModule.forRoot = /**
     * @param {?} customErrorMessages
     * @return {?}
     */
    function (customErrorMessages) {
        return {
            ngModule: NgxBootstrapValidationModule,
            providers: [
                {
                    provide: CUSTOM_ERROR_MESSAGES,
                    useValue: customErrorMessages || [],
                    multi: true
                }
            ]
        };
    };
    NgxBootstrapValidationModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [
                        FormControlDirective,
                        FormDirective,
                        ParentFormDirective,
                        ValidationFeedbackComponent,
                        FormGroupComponent
                    ],
                    imports: [
                        CommonModule
                    ],
                    exports: [
                        FormControlDirective,
                        FormDirective,
                        ParentFormDirective,
                        ValidationFeedbackComponent,
                        FormGroupComponent
                    ]
                },] }
    ];
    return NgxBootstrapValidationModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { FormGroupComponent, ValidationFeedbackComponent, controlPath, FormControlDirective, FormDirective, NgxBootstrapValidationModule, ParentFormDirective as ɵc, CUSTOM_ERROR_MESSAGES as ɵa };

//# sourceMappingURL=wizpanda-ngx-bootstrap-validation.js.map